
*there is no urban_lev for NL and SI
*   
forvalues y=2003/2012 {
foreach c in AT BE BG CZ DE DK EE ES  FI  FR GR HU IT LT LV NL PL PT RO SE SI SK UK {

use silc_for_analysis, clear

keep if year==`y'
keep if country=="`c'"
count
if r(N)!=0 {

keep if age>15 & age<66

capture drop _supp _match

***selection variables
bys id_h: egen benefit_h=max(benefit)

gen other_emp=0
replace other_emp=1 if status>4 & nr_emp>0
replace other_emp=1 if status<4 & nr_emp>1

gen kids_h=nr_kids>0
***


local restrict 	"employee==1 & gross_wage_m!=. & gross_wage_m>0 & hours_main==hours_total & months_ft_work==12"
count if `restrict' & age!=. & heduc!=. & meduc!=. & marr!=. & agr!=. & con!=. & mser!=. & micro!=. & small!=. & isco1_3!=. & isco4_5!=. & isco6!=. & isco7!=. & isco8!=. 
if r(N)!=0 {

gen E=(`restrict')
keep if act==1

if "`c'"!="NL" & "`c'"!="SI" {
tab urban_lev, g(d_urban)
drop d_urban1
}

replace lwage_h=. if employee!=1 | gross_wage_m==. | gross_wage_m<=0 | hours_main!=hours_total | months_ft_work!=12
replace wage_h=. if employee!=1 | gross_wage_m==. | gross_wage_m<=0 | hours_main!=hours_total | months_ft_work!=12

if "`c'"!="NL" & "`c'"!="SI" {
local basic 	"age agesq heduc meduc marr d_urban*"
local basicN	"age_w educ_w marr urban_lev"
}
if "`c'"=="NL" | "`c'"=="SI" {
local basic 	"age agesq heduc meduc marr"
local basicN	"age_w educ_w marr"
}

local ind		"`basic' agr con mser nmser"
local ind2		"`basic' agr con mser nmser micro small"
local occ		"`basic' isco1_3 isco4_5 isco6 isco7 isco8"
local indocc	"`ind' isco1_3 isco4_5 isco6 isco7 isco8"
local ind2occ	"`indocc' micro small" 

local specif	 basic ind ind2 occ indocc ind2occ raw

local weights	"[aw=weight]"

local heckman_s "model1(heckman, twostep select(E = kids_h benefit_h other_emp)) model2(heckman, twostep select(E = kids_h benefit_h other_emp))"


foreach vars in `basicN' {
drop if `vars' ==.
}

local methods 	blin hblin oaxa hoaxa sloc hsloc cott hcott reim hreim fort neum  ///
				jmp25_cott jmp50_cott jmp75_cott ///
				jmp25_oaxa jmp50_oaxa jmp75_oaxa ///
				jmp25_blin jmp50_blin jmp75_blin ///
				jmp25_fort jmp50_fort jmp75_fort ///
				jmp25_neum jmp50_neum jmp75_neum ///
				rif25_blin rif50_blin rif75_blin ///
				rif25_oaxa rif50_oaxa rif75_oaxa ///
				rif25_sloc rif50_sloc rif75_sloc ///
				rif25_cott rif50_cott rif75_cott ///
				rif25_reim rif50_reim rif75_reim ///
				rif25_fort rif50_fort rif75_fort ///
				rif25_neum rif50_neum rif75_neum ///
				dflm dfl25 dfl50 dfl75 nopo 

local nmethods : word count `methods'
local nspecif:	word count `specif'
matrix totals`c'`y' = J(`nmethods',`nspecif',.)
matrix colnames totals`c'`y' 	=	`specif'
matrix rownames totals`c'`y'	=	`methods'

matrix errors`c'`y' = J(`nmethods',`nspecif',.)
matrix colnames errors`c'`y' 	=	`specif'
matrix rownames errors`c'`y'	=	`methods'

local icol = 0

save data_aux, replace
							
foreach group in basic ind ind2 occ indocc ind2occ {

use data_aux, replace

local icol =`icol'+1

local irow = 1

*OB
 mean sex if `restrict'
matrix m = e(b)
local avg = m[1,1]
local avg2=	1- m[1,1]
local options "w(0) w(1) w(`avg') w(`avg2') w(.5)"  


foreach cases in `options' {
 oaxaca lwage_h ``group''  if `restrict' `weights', by(sex) `cases' relax
matrix b	=	e(b)
matrix totals`c'`y'[`irow',`icol']= b[1,3] - b[1,4]
lincom difference-explained 
matrix errors`c'`y'[`irow',`icol']= r(se)
if "`group'" == "basic" {
matrix totals`c'`y'[`irow', 7] = b[1,3]
lincom difference
matrix errors`c'`y'[`irow',7]= r(se)
}
local irow = `irow' +1

matrix drop b

 oaxaca lwage_h ``group'' , by(sex) `cases' `heckman_s' relax
matrix b	=	e(b)
matrix totals`c'`y'[`irow',`icol']= b[1,3] - b[1,4]
lincom difference-explained 
matrix errors`c'`y'[`irow',`icol']= r(se)
if "`group'" == "basic" {
matrix totals`c'`y'[`irow', 7] = b[1,3]
lincom difference
matrix errors`c'`y'[`irow',7]= r(se)
}
local irow = `irow' +1

matrix drop b
}


local options "pooled omega"  


foreach cases in `options' {
 oaxaca lwage_h ``group''  if `restrict' `weights', by(sex) `cases' relax
matrix b	=	e(b)
matrix totals`c'`y'[`irow',`icol']= b[1,3] - b[1,4]
lincom difference-explained 
matrix errors`c'`y'[`irow',`icol']= r(se)
if "`group'" == "basic" {
matrix totals`c'`y'[`irow', 7] = b[1,3]
lincom difference
matrix errors`c'`y'[`irow',7]= r(se)
}
local irow = `irow' +1

matrix drop b
}

*JMP
forvalues cases=0/2 {
foreach k in 0 1 {
capture estimates drop sex`k'
 reg lwage_h ``group'' `weights' if  sex==`k' & `restrict'
estimates store sex`k'
}

 jmpierce sex0 sex1, reference(`cases') statistics(p25 p50 p75)
matrix 	b	=	r(D)
matrix totals`c'`y'[`irow', `icol'] = b[1,1]-b[1,2]
if "`group'" == "basic" {
matrix totals`c'`y'[`irow', 7] = b[1,1]
}
local irow = `irow' +1
matrix totals`c'`y'[`irow', `icol'] = b[2,1]-b[2,2]
if "`group'" == "basic" {
matrix totals`c'`y'[`irow', 7] = b[2,1]
}
local irow = `irow' +1
matrix totals`c'`y'[`irow', `icol'] = b[3,1]-b[3,2]
if "`group'" == "basic" {
matrix totals`c'`y'[`irow', 7] = b[3,1]
}
local irow = `irow' +1

capture drop _est_sex0 _est_sex1
matrix drop b
}

*JMP fortin

foreach k in 0 1 {
capture estimates drop sex`k'
 reg lwage_h ``group'' `weights' if  sex==`k' & `restrict'
estimates store sex`k'
}

reg lwage_h ``group'' sex `weights' if `restrict'
 jmpierce sex0 sex1, reference(.) statistics(p25 p50 p75)
matrix 	b	=	r(D)
matrix totals`c'`y'[`irow', `icol'] = b[1,1]-b[1,2]
if "`group'" == "basic" {
matrix totals`c'`y'[`irow', 7] = b[1,1]
}
local irow = `irow' +1
matrix totals`c'`y'[`irow', `icol'] = b[2,1]-b[2,2]
if "`group'" == "basic" {
matrix totals`c'`y'[`irow', 7] = b[2,1]
}
local irow = `irow' +1
matrix totals`c'`y'[`irow', `icol'] = b[3,1]-b[3,2]
if "`group'" == "basic" {
matrix totals`c'`y'[`irow', 7] = b[3,1]
}
local irow = `irow' +1

capture drop _est_sex0 _est_sex1
matrix drop b

*JMP Neumark
foreach k in 0 1 {
capture estimates drop sex`k'
 reg lwage_h ``group'' `weights' if  sex==`k' & `restrict'
estimates store sex`k'
}

reg lwage_h ``group'' `weights' if `restrict'
 jmpierce sex0 sex1, reference(.) statistics(p25 p50 p75)
matrix 	b	=	r(D)
matrix totals`c'`y'[`irow', `icol'] = b[1,1]-b[1,2]
if "`group'" == "basic" {
matrix totals`c'`y'[`irow', 7] = b[1,1]
}
local irow = `irow' +1
matrix totals`c'`y'[`irow', `icol'] = b[2,1]-b[2,2]
if "`group'" == "basic" {
matrix totals`c'`y'[`irow', 7] = b[2,1]
}
local irow = `irow' +1
matrix totals`c'`y'[`irow', `icol'] = b[3,1]-b[3,2]
if "`group'" == "basic" {
matrix totals`c'`y'[`irow', 7] = b[3,1]
}
local irow = `irow' +1

capture drop _est_sex0 _est_sex1
matrix drop b

*RIF
 mean sex if `restrict'
matrix m = e(b)
local avg = m[1,1]
local avg2=	1- m[1,1]
local opt_w "w(0) w(1) w(`avg') w(`avg2') w(.5) pooled omega" 
local options "q(0.25) q(0.5) q(0.75)"

foreach cases in `opt_w' {
foreach i in `options'{

capture drop rif*
gen rif_1=.


rifreg lwage_h ``group''  `weights' if sex==0 & `restrict', `i'  re(rifm)
replace rif_1 = rifm if sex==0

rifreg lwage_h ``group'' `weights' if sex==1 & `restrict' , `i' re(riff)
replace rif_1=riff if sex==1

oaxaca rif_1 ``group'' if `restrict' , by(sex) `cases' relax
matrix b	=	e(b)
matrix totals`c'`y'[`irow',`icol']= b[1,3] - b[1,4]
lincom difference-explained
matrix errors`c'`y'[`irow',`icol']= r(se)
if "`group'" == "basic" {
matrix totals`c'`y'[`irow', 7] = b[1,3]
lincom difference
matrix errors`c'`y'[`irow',7]= r(se)
}
local irow = `irow' +1
}

matrix drop b
capture drop rif*
}
//

probit sex2 ``group'' if `restrict' 
predict double phat`icol'
gen double wgt`icol' = (1-phat`icol')/phat`icol'

matrix dfl =J(4,3,-99)
_pctile lwage_h [aw=wgt`icol'*weight] if sex==0 & `restrict', nquantiles(4) 

matrix dfl [2,1]	=	r(r1)
matrix dfl [3,1]	=	r(r2)
matrix dfl [4,1]	=	r(r3)

_pctile lwage_h [aw=weight] if sex==0 & `restrict', nquantiles(4) 

matrix dfl [2,2]	=	r(r1)
matrix dfl [3,2]	=	r(r2)
matrix dfl [4,2]	=	r(r3)

_pctile lwage_h [aw=weight] if sex==1 & `restrict', nquantiles(4) 

matrix dfl [2,3]	=	r(r1)
matrix dfl [3,3]	=	r(r2)
matrix dfl [4,3]	=	r(r3)


sum lwage_h [aw=wgt`icol'*weight] if sex==0 & `restrict'
matrix dfl [1,1]	=	r(mean)

sum lwage_h [aw=weight] if sex==0 & `restrict'
matrix dfl [1,2]	=	r(mean)

sum lwage_h [aw=weight] if sex==1 & `restrict'
matrix dfl [1,3]	=	r(mean)


forvalues s = 1/4{
if "`group'" == "basic" {
matrix totals`c'`y'[`irow',7]	=	dfl[`s',2] - dfl[`s',3] //total
}
matrix totals`c'`y'[`irow',`icol']	=	dfl[`s',1] - dfl[`s',3] //unexplained
local irow = `irow' +1
}
matrix drop dfl
drop phat wgt


if "`group'" == "basic" {
 nopomatch `basicN' if `restrict',  outcome(wage_h) by(sex2) fact(weight) sd filename(nopo_w`icol')
count if `restrict'
 }
if "`group'" == "ind" {
 use data_aux, clear
 drop if ind_w==.
 nopomatch `basicN' ind_w if `restrict', outcome(wage_h) by(sex2) fact(weight) sd filename(nopo_w`icol') 
 count if `restrict'
 }
if "`group'" == "occ" {
 use data_aux, clear
 drop if occ ==.
 nopomatch `basicN' occ if `restrict', outcome(wage_h) by(sex2) fact(weight) sd filename(nopo_w`icol')
count if `restrict'
 }
if "`group'" == "ind2" {
 use data_aux, clear
 drop if ind_w==. | fsize==. 
 nopomatch `basicN' ind_w fsize  if `restrict', outcome(wage_h) by(sex2) fact(weight) sd filename(nopo_w`icol') 
count if `restrict'
 }
if "`group'" == "indocc" {
 use data_aux, clear
 drop if ind_w==. |occ==. 

 nopomatch `basicN' occ ind_w  if `restrict', outcome(wage_h) by(sex2) fact(weight) sd filename(nopo_w`icol') 
count if `restrict'
 }
  if "`group'" == "ind2occ" {
 use data_aux, clear
 drop if ind_w==. | fsize==. | occ==. 
 nopomatch `basicN' occ ind_w fsize  if `restrict', outcome(wage_h) by(sex2) fact(weight) sd filename(nopo_w`icol') 
count if `restrict'
 }


capture drop _supp _match

}

clear
gen ziuta=1
forvalues i = 1/6 {
		append using nopo_w`i'
		erase nopo_w`i'.dta
	}
drop ziuta

mkmat D D0 DF DM DX percM percF sdev, matrix(nopo`c'`y') roweq(controls)
matrix l nopo`c'`y', format(%9.4f) title("Nopo")

forvalues n=1/6 {
matrix totals`c'`y'[`nmethods',`n']	=	nopo`c'`y'[`n',2]
matrix errors`c'`y'[`nmethods',`n']	=	nopo`c'`y'[`n',8]
}
matrix totals`c'`y'[`nmethods',7]	=	nopo`c'`y'[1,1]
matrix l totals`c'`y', format(%9.3f) title(`dowhat')

clear
svmat totals`c'`y'
count
gen country="`c'"
gen year=`y'
gen method="."
local nr_method=0
foreach method in `methods' {
local nr_method=`nr_method'+1
replace method="`method'" if _n==`nr_method'
}
save methods`c'`y'_for_paper, replace

clear
svmat errors`c'`y'
gen country="`c'"
gen year=`y'
gen method="."
local nr_method=0
foreach method in `methods' {
local nr_method=`nr_method'+1
replace method="`method'" if _n==`nr_method'
}
save errors`c'`y'_for_paper, replace
}
}
}
}
****MAKING BIG DATABASE

clear
gen gwg_estimates_for_paper=1
save gwg_estimates_for_paper, replace

forvalues y=2003/2012 {
foreach c in AT BE BG CZ DE DK EE ES  FI  FR GR HU IT LT LV NL PL PT RO SE SI SK UK {
clear
capture use methods`c'`y'_for_paper
count
if r(N)!=0 {

reshape long totals`c'`y', i(method) j(set)
rename totals`c'`y' gwg
gen set_s="."
replace set_s="basic" if set==1
replace set_s="ind" if set==2
replace set_s="ind2" if set==3
replace set_s="occ" if set==4
replace set_s="indocc" if set==5
replace set_s="ind2occ" if set==6
replace set_s="raw" if set==7
append using gwg_estimates_for_paper
erase methods`c'`y'_for_paper.dta
save gwg_estimates_for_paper, replace
}
}
}
drop gwg_estimates_for_paper
save gwg_estimates_for_paper, replace


clear
gen se_estimates_for_paper=1
save se_estimates_for_paper, replace

forvalues y=2003/2012 {
foreach c in AT BE BG CZ DE DK EE ES  FI  FR GR HU IT LT LV NL PL PT RO SE SI SK UK {
clear
capture use errors`c'`y'_for_paper
count
if r(N)!=0 {

reshape long errors`c'`y', i(method) j(set)
rename errors`c'`y' se
gen set_s="."
replace set_s="basic" if set==1
replace set_s="ind" if set==2
replace set_s="ind2" if set==3
replace set_s="occ" if set==4
replace set_s="indocc" if set==5
replace set_s="ind2occ" if set==6
replace set_s="raw" if set==7
append using se_estimates_for_paper
erase errors`c'`y'_for_paper.dta
save se_estimates_for_paper, replace
}
}
}

gen trans=0 
replace trans=1 if country=="PL" | country=="LV" | country=="RO" | country=="SI" | country=="SK" | country=="EE" | country=="CZ" | country=="BG" | country=="LT" | country=="HU"
drop se_estimates_for_paper
save se_estimates_for_paper, replace

use gwg_estimates_for_paper, clear
merge 1:1 country year method set set_s using se_estimates_for_paper
drop _merge
erase se_estimates_for_paper.dta
save gwg_estimates_for_paper, replace
